Merge branch 'mt/t4129-with-setgid-dir'
[git] / t / perf / perf-lib.sh
1 # Performance testing framework.  Each perf script starts much like
2 # a normal test script, except it sources this library instead of
3 # test-lib.sh.  See t/perf/README for documentation.
4 #
5 # Copyright (c) 2011 Thomas Rast
6 #
7 # This program is free software: you can redistribute it and/or modify
8 # it under the terms of the GNU General Public License as published by
9 # the Free Software Foundation, either version 2 of the License, or
10 # (at your option) any later version.
11 #
12 # This program is distributed in the hope that it will be useful,
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
15 # GNU General Public License for more details.
16 #
17 # You should have received a copy of the GNU General Public License
18 # along with this program.  If not, see http://www.gnu.org/licenses/ .
19
20 # These variables must be set before the inclusion of test-lib.sh below,
21 # because it will change our working directory.
22 TEST_DIRECTORY=$(pwd)/..
23 TEST_OUTPUT_DIRECTORY=$(pwd)
24
25 TEST_NO_CREATE_REPO=t
26 TEST_NO_MALLOC_CHECK=t
27
28 . ../test-lib.sh
29
30 if test -n "$GIT_TEST_INSTALLED" -a -z "$PERF_SET_GIT_TEST_INSTALLED"
31 then
32         error "Do not use GIT_TEST_INSTALLED with the perf tests.
33
34 Instead use:
35
36     ./run <path-to-git> -- <tests>
37
38 See t/perf/README for details."
39 fi
40
41 # Variables from test-lib that are normally internal to the tests; we
42 # need to export them for test_perf subshells
43 export TEST_DIRECTORY TRASH_DIRECTORY GIT_BUILD_DIR GIT_TEST_CMP
44
45 MODERN_GIT=$GIT_BUILD_DIR/bin-wrappers/git
46 export MODERN_GIT
47
48 perf_results_dir=$TEST_OUTPUT_DIRECTORY/test-results
49 test -n "$GIT_PERF_SUBSECTION" && perf_results_dir="$perf_results_dir/$GIT_PERF_SUBSECTION"
50 mkdir -p "$perf_results_dir"
51 rm -f "$perf_results_dir"/$(basename "$0" .sh).subtests
52
53 die_if_build_dir_not_repo () {
54         if ! ( cd "$TEST_DIRECTORY/.." &&
55                     git rev-parse --build-dir >/dev/null 2>&1 ); then
56                 error "No $1 defined, and your build directory is not a repo"
57         fi
58 }
59
60 if test -z "$GIT_PERF_REPO"; then
61         die_if_build_dir_not_repo '$GIT_PERF_REPO'
62         GIT_PERF_REPO=$TEST_DIRECTORY/..
63 fi
64 if test -z "$GIT_PERF_LARGE_REPO"; then
65         die_if_build_dir_not_repo '$GIT_PERF_LARGE_REPO'
66         GIT_PERF_LARGE_REPO=$TEST_DIRECTORY/..
67 fi
68
69 test_perf_do_repo_symlink_config_ () {
70         test_have_prereq SYMLINKS || git config core.symlinks false
71 }
72
73 test_perf_create_repo_from () {
74         test "$#" = 2 ||
75         BUG "not 2 parameters to test-create-repo"
76         repo="$1"
77         source="$2"
78         source_git="$("$MODERN_GIT" -C "$source" rev-parse --git-dir)"
79         objects_dir="$("$MODERN_GIT" -C "$source" rev-parse --git-path objects)"
80         mkdir -p "$repo/.git"
81         (
82                 cd "$source" &&
83                 { cp -Rl "$objects_dir" "$repo/.git/" 2>/dev/null ||
84                         cp -R "$objects_dir" "$repo/.git/"; } &&
85                 for stuff in "$source_git"/*; do
86                         case "$stuff" in
87                                 */objects|*/hooks|*/config|*/commondir)
88                                         ;;
89                                 *)
90                                         cp -R "$stuff" "$repo/.git/" || exit 1
91                                         ;;
92                         esac
93                 done
94         ) &&
95         (
96                 cd "$repo" &&
97                 "$MODERN_GIT" init -q &&
98                 test_perf_do_repo_symlink_config_ &&
99                 mv .git/hooks .git/hooks-disabled 2>/dev/null &&
100                 if test -f .git/index.lock
101                 then
102                         # We may be copying a repo that can't run "git
103                         # status" due to a locked index. Since we have
104                         # a copy it's fine to remove the lock.
105                         rm .git/index.lock
106                 fi
107         ) || error "failed to copy repository '$source' to '$repo'"
108 }
109
110 # call at least one of these to establish an appropriately-sized repository
111 test_perf_fresh_repo () {
112         repo="${1:-$TRASH_DIRECTORY}"
113         "$MODERN_GIT" init -q "$repo" &&
114         (
115                 cd "$repo" &&
116                 test_perf_do_repo_symlink_config_
117         )
118 }
119
120 test_perf_default_repo () {
121         test_perf_create_repo_from "${1:-$TRASH_DIRECTORY}" "$GIT_PERF_REPO"
122 }
123 test_perf_large_repo () {
124         if test "$GIT_PERF_LARGE_REPO" = "$GIT_BUILD_DIR"; then
125                 echo "warning: \$GIT_PERF_LARGE_REPO is \$GIT_BUILD_DIR." >&2
126                 echo "warning: This will work, but may not be a sufficiently large repo" >&2
127                 echo "warning: for representative measurements." >&2
128         fi
129         test_perf_create_repo_from "${1:-$TRASH_DIRECTORY}" "$GIT_PERF_LARGE_REPO"
130 }
131 test_checkout_worktree () {
132         git checkout-index -u -a ||
133         error "git checkout-index failed"
134 }
135
136 # Performance tests should never fail.  If they do, stop immediately
137 immediate=t
138
139 # Perf tests require GNU time
140 case "$(uname -s)" in Darwin) GTIME="${GTIME:-gtime}";; esac
141 GTIME="${GTIME:-/usr/bin/time}"
142
143 test_run_perf_ () {
144         test_cleanup=:
145         test_export_="test_cleanup"
146         export test_cleanup test_export_
147         "$GTIME" -f "%E %U %S" -o test_time.$i "$SHELL" -c '
148 . '"$TEST_DIRECTORY"/test-lib-functions.sh'
149 test_export () {
150         test_export_="$test_export_ $*"
151 }
152 '"$1"'
153 ret=$?
154 needles=
155 for v in $test_export_
156 do
157         needles="$needles;s/^$v=/export $v=/p"
158 done
159 set | sed -n "s'"/'/'\\\\''/g"'$needles" >test_vars
160 exit $ret' >&3 2>&4
161         eval_ret=$?
162
163         if test $eval_ret = 0 || test -n "$expecting_failure"
164         then
165                 test_eval_ "$test_cleanup"
166                 . ./test_vars || error "failed to load updated environment"
167         fi
168         if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
169                 echo ""
170         fi
171         return "$eval_ret"
172 }
173
174 test_wrapper_ () {
175         test_wrapper_func_=$1; shift
176         test_start_
177         test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
178         test "$#" = 2 ||
179         BUG "not 2 or 3 parameters to test-expect-success"
180         export test_prereq
181         if ! test_skip "$@"
182         then
183                 base=$(basename "$0" .sh)
184                 echo "$test_count" >>"$perf_results_dir"/$base.subtests
185                 echo "$1" >"$perf_results_dir"/$base.$test_count.descr
186                 base="$perf_results_dir"/"$PERF_RESULTS_PREFIX$(basename "$0" .sh)"."$test_count"
187                 "$test_wrapper_func_" "$@"
188         fi
189
190         test_finish_
191 }
192
193 test_perf_ () {
194         if test -z "$verbose"; then
195                 printf "%s" "perf $test_count - $1:"
196         else
197                 echo "perf $test_count - $1:"
198         fi
199         for i in $(test_seq 1 $GIT_PERF_REPEAT_COUNT); do
200                 say >&3 "running: $2"
201                 if test_run_perf_ "$2"
202                 then
203                         if test -z "$verbose"; then
204                                 printf " %s" "$i"
205                         else
206                                 echo "* timing run $i/$GIT_PERF_REPEAT_COUNT:"
207                         fi
208                 else
209                         test -z "$verbose" && echo
210                         test_failure_ "$@"
211                         break
212                 fi
213         done
214         if test -z "$verbose"; then
215                 echo " ok"
216         else
217                 test_ok_ "$1"
218         fi
219         "$TEST_DIRECTORY"/perf/min_time.perl test_time.* >"$base".result
220 }
221
222 test_perf () {
223         test_wrapper_ test_perf_ "$@"
224 }
225
226 test_size_ () {
227         say >&3 "running: $2"
228         if test_eval_ "$2" 3>"$base".result; then
229                 test_ok_ "$1"
230         else
231                 test_failure_ "$@"
232         fi
233 }
234
235 test_size () {
236         test_wrapper_ test_size_ "$@"
237 }
238
239 # We extend test_done to print timings at the end (./run disables this
240 # and does it after running everything)
241 test_at_end_hook_ () {
242         if test -z "$GIT_PERF_AGGREGATING_LATER"; then
243                 ( cd "$TEST_DIRECTORY"/perf && ./aggregate.perl $(basename "$0") )
244         fi
245 }
246
247 test_export () {
248         export "$@"
249 }
250
251 test_lazy_prereq PERF_EXTRA 'test_bool_env GIT_PERF_EXTRA false'